﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	
	Private mTableView As TableView
	Private TableData As List
	Private mTableViewUtils As TableViewUtils
	Private CFH0,CFH1,CFH2 As TVCellFactoryHelper
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(TV As TableView)

	mTableView = TV
	mTableViewUtils.Initialize(mTableView)

	Dim FXCollections As JavaObject
	FXCollections.InitializeStatic("javafx.collections.FXCollections")
	
	DefineColumns

End Sub
'Set the data for the list view
Sub setData(Data As List)
	TableData = Data
	SetupTableViewCF

End Sub
'initialize the listview with cellfactory objects
Sub SetupTableViewCF

	mTableView.Items.Clear

	For i = 0 To TableData.Size - 1
		Dim RowData() As Object = TableData.Get(i)
		Dim Row(RowData.Length) As Object
		'Add a cellfactoryobject for Column and Row in the array
		For j = 0 To RowData.Length - 1
			Dim CFO As CellFactoryObject
			CFO.Initialize
			Row(j) = CFO
		Next
		mTableView.Items.Add(Row)
	Next
End Sub
Sub DefineColumns
	Dim T1 As JavaObject = mTableView
	Dim ColOL As JavaObject = T1.RunMethod("getColumns",Null)

	For i = 0 To ColOL.RunMethod("size",Null) - 1
		Dim Col As JavaObject = ColOL.RunMethod("get",Array As Object(i))
		
		Select i
			Case 0,3,6,9,12,15,18,21
				CFH0.Initialize(CFH1.TYPETEXT,0,Col)
				
			Case 1,4,7,10,13,16,19,22
				CFH1.Initialize(CFH1.TYPETEXT,1,Col)
			
			Case 2,5,8,11,14,17,20,23
				CFH2.Initialize(CFH1.TYPETEXT,2,Col)
				
		End Select
		
		'Autosize the columns on Form resize
		Col.RunMethodJO("prefWidthProperty",Null).RunMethod("bind",Array As Object(T1.RunMethodJO("widthProperty",Null).RunMethod("divide",Array As Object(25))))
	Next
End Sub
#Region Data Access Subs 
Sub getRowData(Index As Int) As Object()
	Return TableData.Get(Index)
End Sub
#End Region Data Access Subs

#Region CellFactory Subs	'########################################################################################################################################

'This sub is used by the cell factory to get the pane to display, You can add UI controls to the AnchorPane.
'The cell is also exposed making it possible to style the cell using CSS inline, or add a style sheet to the cell with JavaObject
'The Id is the one provided in the Helper Initialization, you can make changes based on the ID, or even create a completely different layout for several different lists.
'If the ListViewHelper has a type TYPETEXT, this sub will not be called.
Sub getGraphic(Id As String,Column As Object) As Object			'Ignore

	#Region Required Code
	'If Required - Convert the Cell related to this Object to a JavaObject
	
	Dim Cell As JavaObject = Sender
	'Instantiate the Pane or Node to be returned
	Dim P As AnchorPane
	P.Initialize("")
	#End Region Required Code

	'User Code - Create a panel to be returned for display in the ListView cell

	
	#Region Required Code
	'Must Return the Pane or Node to be displayed
	Return P
	#End Region Required Code
End Sub

'This sub is used by the cell factory to get the text to display for this object, you can create a string to return from the fields available or any other code.
'The Id is the one provided in the Helper Initialization, you can make changes to the text based on the ID or use it for different Lists.
'If the ListViewHelper has a type TYPEGRAPHIC, this sub will not be called.
Sub getText(Id As String,CallingCell As Object) As String			
#Region Required Code
	Dim ReturnString As String

	'Record the Cell related to this Object once it has been displayed
	Dim Cell As JavaObject = Sender
#End Region Required Code
	
	'User Code
	'Set the text to display
	Dim RowIndex As Int = CellUtilsStatic.RowIndex(Cell)
	Dim Row() As Object = TableData.Get(RowIndex)
	Dim ColumnIndex As Int = CellUtilsStatic.ColumnIndex(Cell,mTableView)
	
	ReturnString = Row(ColumnIndex)
	
	'As the cells are reused as they are displayed, remove any residual styles for this cell
	Cell.RunMethod("setStyle",Array(""))
	
	'As the cells are reused as they are displayed, remove any residual styles for this cell
	Cell.RunMethod("setStyle",Array(""))
	
	'Set style on the Cell for the current object
	Dim C As Node = Cell
	'Change the text alignment for all cells
	C.Style = "-fx-alignment:center-right;"
	
	'Just for the third columns style the right border
	If Id = 2 Then
		C.Style = C.Style & "-fx-border-width:1px 3px 1px 1px;-fx-border-color:transparent black transparent transparent;"	
	End If

		
#Region Required Code
	'Must return a String
	Return ReturnString
#End Region Required code
End Sub

#End Region Cell Factory Subs





